#include <stdio.h>
#include <string.h>
#include <math.h>


int cn=0;			//    -
float *c = NULL;	//  -
char *cc = NULL;	//  'M'  'm'     

int m=0, n=0;		//   
float **a = NULL;	//  
float *b = NULL;	//     

int *base = NULL;	//  

float zb, zbm;		//   b  b__M-
float *za = NULL;	//   a
float *zam = NULL;	//   __M-

int base_column;	//  
int base_row;		//  

//int k_artificial = 0;	// -  c 
int *dropoutm = NULL;	//   c 
int dompos = 0;			//       dropoutm


void FreeMem()
{
	delete[] zam;
	delete[] za;
	delete[] base;
	delete[] b;

	for (int i=0; i<m; i++)
		delete[] a[i];
	delete[] a;

	delete[] dropoutm;
	delete[] cc;
	delete[] c;
}

bool ReadInput(char *filename)
{
	int i,j;
	FILE *f = fopen(filename, "r");
	if (NULL == f)
		return false;

	//  -
	fscanf(f, "%i", &cn);
	c = new float [cn];
	cc = new char [cn];


	int k_artificial = 0;	// -  c 
	dompos = 0;

	for (i=0; i<cn; i++)
	{
		fscanf(f, "%f %c", &c[i], &cc[i]);

		if ('M' == cc[i] || 'm' == cc[i])
			++k_artificial;
	}

	if (k_artificial)
	{
		dropoutm = new int[k_artificial];
		for (i=0; i<k_artificial; i++)
			dropoutm[i] = -1;
	}


	//  
	fscanf(f, "%i %i", &n, &m);
	a = new float* [m];

	for (i=0; i<m; i++)
		a[i] = new float[n];

	b = new float [m];

	for (j=0; j<m; j++)
	{
		for (i=0; i<n; i++)
			fscanf(f, "%f", &a[j][i]);

		fscanf(f, "%f", &b[j]);
	}


	//  
	base = new int [m];

	for (j=0; j<m; j++)
	{
		fscanf(f, "%i", &base[j]);
		--base[j];
	}


	fclose(f);

	za = new float[n];
	zam = new float[n];

	return true;
}

//  true,  vector-    dropoutm
bool CheckDropOut(int vector)
{
	for (int i=0; i<dompos; i++)
		if (dropoutm[i] == vector)
			return true;

	return false;
}

// 
void EvaluationOptimal()
{
	int i,j;
	zb=0.0, zbm=0.0;
	for (i=0; i<n; i++) {za[i]=0.0; zam[i]=0.0;}

	for (j=0; j<m; j++)
	{
		if ('M' == cc[base[j]] || 'm' == cc[base[j]])
			zbm += (c[base[j]]<0 ? -b[j] : b[j]);
		else
			zb += c[base[j]]*b[j];

		for (i=0; i<n; i++)
		{
			if ('M' == cc[base[j]] || 'm' == cc[base[j]])
				zam[i] += a[j][i]*(c[base[j]]<0 ? -1 : 1);
			else
				za[i] += c[base[j]]*a[j][i];
		}
	}

	for (i=0; i<n; i++)
	{
		if ('M' == cc[i] || 'm' == cc[i])
			zam[i] -= (c[i]<0 ? -1 : 1);
		else
			za[i] -= c[i];
	}
}

// 
bool CheckStrongPlan()
{
	int i,j;
	float za_min = 0.0;
	base_column =		//  
	base_row = -1;		//  

	//   
	for (i=0; i<n; i++)
	{
		if (CheckDropOut(i) || (za[i] >= 0.0 && zam[i] >= 0.0))
			continue;
		else if (za[i] < za_min)
		{
			za_min = za[i];
			base_column = i;
		}
		else if (zam[i] < za_min)
		{
			za_min = zam[i];
			base_column = i;
		}
	}

	if (-1 == base_column)
		return false;


	za_min = 1000000.0; // !!! FIXME !!!

	//   
	for (j=0; j<m; j++)
	{
		if (a[j][base_column] > 0.0)
		{
			float t = b[j]/a[j][base_column];
			if (t < za_min)
			{
				za_min = t;
				base_row = j;
			}
		}
	}

	if (-1 == base_row)
		return false;


	// ,   -     dropoutm
	if ('M' == cc[base[base_row]] || 'm' == cc[base[base_row]])
	{
		if (!CheckDropOut(base[base_row]))
			dropoutm[dompos++] = base[base_row];
	}


//	base[base_row] = base_column; // !!!
									// !!!
	return true;					// !!!
}									// !!!
									// !!!
// 							// !!!
void Transformation()				// !!!
{									// !!!
	base[base_row] = base_column; /* !!! ,  base_row 
									base_column   !!! */

	int i,j;

	float **a2 = new float* [m];	//  
	float *b2 = new float [m];	//     
	memcpy(b2,b,m*sizeof(float));

	for (j=0; j<m; j++)
	{
		a2[j] = new float[n];
		memcpy(a2[j],a[j],n*sizeof(float));
	}



	for (j=0; j<m; j++)
	{
		for (i=0; i<n; i++)
		{
			if (i == base_column)
			{
				if (j == base_row)
					a2[j][i] = 1.0;
				else
					a2[j][i] = 0.0;
			}
			else
			{
				if (j == base_row)
					a2[j][i] = a[j][i]/a[base_row][base_column];
				else
					a2[j][i] = a[j][i] - a[base_row][i]*a[j][base_column]/
						a[base_row][base_column];
			}
		}

		if (j == base_row)
			b2[j] = b[j]/a[base_row][base_column];
		else
			b2[j] = b[j] - b[base_row]*a[j][base_column]/
				a[base_row][base_column];
	}



	memcpy(b,b2,m*sizeof(float));
	delete[] b2;

	for (j=0; j<m; j++)
	{
		memcpy(a[j],a2[j],n*sizeof(float));
		delete[] a2[j];
	}

	delete[] a2;
}

void Rule(char c, int amount = 5+(n+2)*8)
{
	for (int i=0; i<amount; i++)
		printf("%c", c);
	printf("\n");
}

void ShowTable()
{
	int i,j;

	static int iteration = 0;

	printf("[%i]\n", iteration++);
	Rule('=');
	printf(".|       |       #");
	for (i=0; i<cn; i++)
	{
		if ('M' == cc[i] || 'm' == cc[i])
			printf("  %cM   |", c[i]<0 ? '-' : ' ');
		else
			printf("%6.2f |", c[i]);
	}
	printf("\n.|  Ci   |  Bi   #");
	Rule('-', n*8);
	printf("    |       |       #");
	for (i=0; i<cn; i++)
		printf("  x%i   |", i+1);
	printf("\n");
	Rule('=');
	for (j=0; j<m; j++)
	{
		printf(" x%i |", base[j]+1);
		if ('M' == cc[base[j]] || 'm' == cc[base[j]])
			printf("  %cM   |", c[base[j]]<0 ? '-' : ' ');
		else
			printf("%6.2f |", c[base[j]]);

		printf("%6.2f #", b[j]);
		for (i=0; i<n; i++)
			printf("%6.2f |", a[j][i]);
		printf("\n");
	}
	Rule('=');
	printf(" Z  |  ---  |%6.2f #", zb);
	for (i=0; i<n; i++)
		printf("%6.2f |", za[i]);
	printf("\n");
	Rule('-');
	printf("(M) |  ---  |%6.2f #", zbm);
	for (i=0; i<n; i++)
		printf("%6.2f |", zam[i]);
	printf("\n");
	Rule('-');

	if (base_column > -1 && base_row > -1)
		printf(" :%2i\n : %2i\n\nX=(",
			base_column+1, base_row+1);
	else
		printf("\nX=(");


	for (i=0; i<n; i++)
	{
		int basen = -1;

		for (j=0; j<m; j++)
			if (base[j] == i) {basen = j; break;}

		printf("%.2f%c ", -1==basen?0.0:b[basen], i!=n-1?',':')');
	}


	printf("\nZ'=%.2f", zb);
	if (0.0 != zbm) printf(" + (%.2f)*M", zbm);
	printf("\n\n\n");
}

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		printf("Missing argument\n");
		return -1;
	}

	if (!ReadInput(argv[1]))
	{
		printf("Error open file %s.\n", argv[1]);
		return -1;
	}


	printf("*** - ***\n\n");
	bool plan;

	for (int k=0; k<2*m+1; k++)
	{
		if (k) Transformation();
		EvaluationOptimal();

		plan = CheckStrongPlan();
		ShowTable();

		if (!plan)
		{
			printf("\n      .\n");
			break;
		}
	}

	FreeMem();
	return 0;
}
